from email.message import EmailMessage
import os
from django.http import Http404
from django.shortcuts import render, redirect
from django.core.mail import send_mail
from django.core.mail import EmailMessage
from django.conf import settings
from ielts_bilaraby import settings
from placement_exam.forms import UserDetailForm
from .models import UserDetail

# Test data
tests = {
    "A1": {
        "questions": [
            {"question": "Choose the correct sentence:", "options": ["She like pizza.", "She likes pizza.", "She liking pizza.", "She is likes pizza."], "answer": 1},
            {"question": "What time is it? 8:30", "options": ["Eight thirty.", "Eight thirteen.", "Half to nine.", "Thirty eight."], "answer": 0},
            {"question": "Where is the cat?", "options": ["Under the table.", "At the table.", "With the table.", "By the table."], "answer": 0},
            {"question": "I _ a book yesterday.", "options": ["read", "reads", "will read", "reading"], "answer": 0},
            {"question": "How do you say 'hello' in English?", "options": ["Bye", "Hello", "Good morning", "Thank you"], "answer": 1},
            {"question": "I can _ to music.", "options": ["listens", "listening", "listen", "listened"], "answer": 2},
            {"question": "What’s the opposite of 'hot'?", "options": ["Warm", "Cold", "Cool", "Freezing"], "answer": 1},
            {"question": "She _ a doctor.", "options": ["is", "are", "am", "be"], "answer": 0},
        ],
        "next": "A2",
    },
    "A2": {
        "questions": [
            {"question": "He usually _ to work at 8 a.m.", "options": ["go", "goes", "going", "gone"], "answer": 1},
            {"question": "Which sentence is correct?", "options": ["I have seen him yesterday.", "I saw him yesterday.", "I seen him yesterday.", "I was seen him yesterday."], "answer": 1},
            {"question": "How long does it take to get to the airport?", "options": ["Two hours.", "Two o’clock.", "About.", "Very long."], "answer": 0},
            {"question": "I can’t find my phone. What is the question?", "options": ["Where is your phone?", "What is your phone?", "Why is your phone?", "Who is your phone?"], "answer": 0},
            {"question": "There aren’t _ apples left.", "options": ["some", "many", "much", "any"], "answer": 3},
            {"question": "She has been living here _ 2015.", "options": ["since", "for", "in", "from"], "answer": 0},
            {"question": "Choose the correct sentence:", "options": ["There is a lot of informations.", "There are many information.", "There is a lot of information.", "There is many information."], "answer": 2},
            {"question": "Which word is different?", "options": ["Chair", "Table", "Window", "Cheese"], "answer": 3},
        ],
        "next": "B1",
    },
    "B1": {
        "questions": [
            {
                "question": "If it _ tomorrow, we’ll cancel the picnic.",
                "options": ["rain", "rains", "rained", "raining"],
                "answer": 1,
            },
            {
                "question": "You look tired. You _ go to bed early.",
                "options": ["should", "must", "could", "can"],
                "answer": 0,
            },
            {
                "question": "I’ve never _ this film before.",
                "options": ["saw", "seeing", "seen", "see"],
                "answer": 2,
            },
            {
                "question": "She asked me where I _.",
                "options": ["live", "lived", "living", "lives"],
                "answer": 1,
            },
            {
                "question": "Which word is closest in meaning to 'happy'?",
                "options": ["Sad", "Angry", "Joyful", "Tired"],
                "answer": 2,
            },
            {
                "question": "Choose the correct sentence:",
                "options": [
                    "The train was late, because of the rain.",
                    "The train was late because it was raining.",
                    "The train was late because was raining.",
                    "The train was late, it was raining.",
                ],
                "answer": 1,
            },
            {
                "question": "I _ work hard to pass the exam.",
                "options": ["have to", "had to", "has to", "has had to"],
                "answer": 0,
            },
            {
                "question": "We _ finished the project by now.",
                "options": ["should've", "must", "can", "would"],
                "answer": 0,
            },
        ],
        "next": "B2",  # Define the next level
    },
    "B2": {
        "questions": [
            {
                "question": "If I _ you, I would take the job.",
                "options": ["were", "was", "am", "will"],
                "answer": 0,
            },
            {
                "question": "He denied _ the money.",
                "options": ["take", "taking", "to take", "taken"],
                "answer": 1,
            },
            {
                "question": "The report must be completed _ Friday.",
                "options": ["by", "on", "until", "for"],
                "answer": 0,
            },
            {
                "question": "Choose the correct sentence:",
                "options": [
                    "It’s high time you take a decision.",
                    "It’s high time you took a decision.",
                    "It’s high time you have taken a decision.",
                    "It’s high time you will take a decision.",
                ],
                "answer": 1,
            },
            {
                "question": "What does the phrase 'on the fence' mean?",
                "options": [
                    "To be undecided",
                    "To be defensive",
                    "To be aggressive",
                    "To be clear",
                ],
                "answer": 0,
            },
            {
                "question": "She works as a lawyer, _?",
                "options": ["does she", "doesn’t she", "isn’t she", "didn’t she"],
                "answer": 1,
            },
            {
                "question": "I’d rather _ at home tonight.",
                "options": ["staying", "to stay", "stay", "stayed"],
                "answer": 2,
            },
            {
                "question": "Choose the synonym of 'complicated':",
                "options": ["Simple", "Complex", "Clear", "Easy"],
                "answer": 1,
            },
        ],
        "next": "C1",  # Define the next level
    },
    "C1": {
        "questions": [
            {
                "question": "Choose the correct word: 'The results were _ surprising.'",
                "options": ["utterly", "too", "much", "highly"],
                "answer": 0,
            },
            {
                "question": "I wish I _ you sooner.",
                "options": ["had met", "met", "have met", "meeting"],
                "answer": 0,
            },
            {
                "question": "She’s considering _ her job to travel the world.",
                "options": ["quitting", "to quit", "quit", "quits"],
                "answer": 0,
            },
            {
                "question": "The study was carried out _ a team of researchers.",
                "options": ["by", "on", "in", "through"],
                "answer": 0,
            },
            {
                "question": "What does 'spill the beans' mean?",
                "options": [
                    "To ruin something",
                    "To reveal a secret",
                    "To clean up",
                    "To waste time",
                ],
                "answer": 1,
            },
            {
                "question": "No sooner _ the bell rung than the students left the room.",
                "options": ["had", "has", "was", "have"],
                "answer": 0,
            },
            {
                "question": "Which word is closest in meaning to 'pervasive'?",
                "options": ["Rare", "Widespread", "Uncommon", "Specific"],
                "answer": 1,
            },
            {
                "question": "If we don’t leave now, we _ the train.",
                "options": ["will miss", "would miss", "miss", "missed"],
                "answer": 0,
            },
        ],
        "next": "C2",
},

"C2": {
    "questions": [
        {
            "question": "Choose the correct option to complete the sentence: 'Despite the difficulties, he managed to complete the project on time, _ his colleagues' skepticism.'",
            "options": ["although", "regardless of", "albeit", "despite of"],
            "answer": 1
        },
        {
            "question": "Identify the grammatical error in the sentence: 'No sooner had he arrived when the meeting started.'",
            "options": ["'No sooner'", "'had he arrived'", "'when'", "'the meeting started'"],
            "answer": 2
        },
        {
            "question": "What does the idiom 'cutting corners' mean?",
            "options": [
                "To take a shortcut",
                "To perform a task poorly to save time or money",
                "To cut through a difficult situation",
                "To avoid conflict"
            ],
            "answer": 1
        },
        {
            "question": "Choose the sentence that uses the subjunctive mood correctly:",
            "options": [
                "If I was you, I would apologize.",
                "If I were you, I would apologize.",
                "If I will be you, I would apologize.",
                "If I am you, I would apologize."
            ],
            "answer": 1
        },
        {
            "question": "Which word is closest in meaning to 'ephemeral'?",
            "options": ["Eternal", "Transient", "Significant", "Indifferent"],
            "answer": 1
        },
        {
            "question": "Complete the sentence: 'The scientist's findings were dismissed as _, lacking sufficient evidence to support the claims.'",
            "options": ["rigorous", "speculative", "meticulous", "substantiated"],
            "answer": 1
        },
        {
            "question": "What type of sentence is this? 'Hardly had the presentation started when the fire alarm went off.'",
            "options": ["Compound", "Complex", "Compound-complex", "Simple"],
            "answer": 1
        },
        {
            "question": "Which of the following sentences uses parallel structure?",
            "options": [
                "He enjoys reading, to play sports, and swimming.",
                "He enjoys reading, playing sports, and swimming.",
                "He enjoys to read, playing sports, and to swim.",
                "He enjoys to read, to play sports, and swimming."
            ],
            "answer": 1
        }
    ],
    "next": None  # No next level as C2 is the final level
}

}


def user_form(request):
    if request.method == 'POST':
        form = UserDetailForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('test_page', user_id=form.instance.id, level="A1")  # Redirect to the test page
    else:
        form = UserDetailForm()
    return render(request, 'placement_exam/user_form.html', {'form': form})


def test_page(request, user_id, level):
    user = UserDetail.objects.get(id=user_id)
    
    # Handle form submission
    if request.method == 'POST':
        # Collect answers
        correct_answers = 0
        for key in request.POST:
            if key.startswith('q'):  # Look for question keys
                question_idx = int(key[1:]) - 1  # Extract question index (1-based to 0-based)
                selected_option = int(request.POST[key])
                # Compare with correct answer
                if selected_option == tests[level]["questions"][question_idx]["answer"]:
                    correct_answers += 1
        
        # Save user's progress
        if correct_answers >= 6:  # Passing threshold
            next_level = tests[level].get("next")
            if next_level:
                return redirect('test_page', user_id=user.id, level=next_level)
            else:
                user.level = level
                user.score = correct_answers
                user.save()
                return redirect('send_email', user_id=user.id)
        else:
            user.level = level
            user.score = correct_answers
            user.save()
            return redirect('send_email', user_id=user.id)

    # Render the static HTML for the test level
    return render(request, f'placement_exam/{level.lower()}_test.html')


def send_email(request, user_id):
    user = UserDetail.objects.get(id=user_id)

    # Email content
    subject = "Your Language Test Results"
    message = f"Dear {user.name},\n\nYour final level is {user.level} with a score of {user.score}.\n\nThank you for taking the test!"
    recipient_list = [user.email]
    from_email = settings.EMAIL_HOST_USER

    # Level-specific image paths
    level_images = {
        "A1": "placement_exam/static/images/a1.JPEG",
        "A2": "placement_exam/static/images/a2.JPEG",
        "B1": "placement_exam/static/images/b1.JPEG",
        "B2": "placement_exam/static/images/b2.JPEG",
        "C1": "placement_exam/static/images/c1.JPEG",
        "C2": "placement_exam/static/images/c2.JPEG",
    }


    # Get the image path for the user's level
    image_path = level_images.get(user.level)

    # Create the email message
    email = EmailMessage(subject, message, from_email, recipient_list)

    # Attach the level-specific image
    if image_path:
        print(f"Looking for file: {image_path}")
        if os.path.exists(image_path):
            try:
                with open(image_path, 'rb') as img:
                    # Correctly attach the image
                    email.attach(f'{user.level}_certificate.jpeg', img.read(), 'image/jpeg')
                    print("Image attached successfully.")
            except Exception as e:
                print(f"Error attaching image: {e}")
        else:
            print(f"File not found: {image_path}")
    else:
        print(f"No image found for level {user.level}. Email will be sent without the image.")

    # Send the email
    try:
        email.send(fail_silently=False)
        print("Email sent successfully.")
    except Exception as e:
        print(f"Failed to send email: {e}")

    return render(request, 'placement_exam/success.html', {'user': user})

def our_vision(request):
    return render(request, 'placement_exam/our_vision.html')